/*
 * utils.js
 * 
 * Copyright (c) 1997 Netscape Communications Corporation, All Rights Reserved
 * 
 * Utility functions for the Netcaster
 */

function jsdebug_break()
{
	var x;
	x = 1;
}

var debug = false;
var platform = 0;
var defaultContainer = null;

function ChannelObject()
{
	this.name = "";
	this.url = "";
	this.desc = "";

	this.intervalTime = 7200;
	this.absoluteTime = 0;
	
	this.estCacheSize = -1;
	this.maxCacheSize = 5000000;

	this.topHint = 0;
	this.leftHint = 0;
	this.widthHint =  screen.availWidth * 2 / 3;
	this.heightHint = screen.availHeight * 3 / 4;

	this.mode="window";

	this.type="1";
	this.depth="2";
	this.crawlExtLinks = true;
}

function batchNetscapePrefs(keys, values, warn, set)
{
	var pref;
	var setPrefs = false;

	if (arguments.length == 4) {
		setPrefs=set;
	}

	if (setPrefs) {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalPreferencesWrite"); 
	} else {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalPreferencesRead"); 
	}

	for (var i=0; i < keys.length; i++) {
		if (setPrefs) {
			var str = 'navigator.preference("' + keys[i] + '", "' + values[i] + '");'
			eval(str);
		} else {
			pref = navigator.preference(keys[i]);

			if ((!pref) || (pref == null)) 
			{
				if (warn)
					alert(getLocalString("The preference ") + keys[i] + getLocalString(" is missing from your preferences file and a default value has been used.  Please contact your administrator."));
			} else {
				values[i] = pref;
			}
		}
	}

	if (setPrefs) {
		navigator.savePreferences();
	}

	return;
}

function GetNetscapePref(prefKey, defaultValue, warn)
{
	var pref;

	netscape.security.PrivilegeManager.enablePrivilege("UniversalPreferencesRead"); 

	pref = navigator.preference(prefKey);

	if ((!pref) || (pref == null)) 
	{
		if (warn)
			alert(getLocalString("The preference ") + prefKey + getLocalString(" is missing from your preferences file and a default value has been used.  Please contact your administrator."));

		pref = defaultValue;
	}

	return pref;
}

function GetNetscapePrefBool(prefKey, defaultValue, warn)
{
	var pref;

	netscape.security.PrivilegeManager.enablePrivilege("UniversalPreferencesRead"); 

	pref = navigator.preference(prefKey);

	if (!pref) {
		return false;
	} else {
		if (pref == null) {
			if (warn)
				alert(getLocalString("The preference ") + prefKey + getLocalString(" is missing from your preferences file and a default value has been used.  Please contact your administrator."));

			pref = defaultValue;
		} else {
			pref = true;
		}
	}	
	
	return pref;
}

function SetNetscapePref(prefKey, value)
{
	netscape.security.PrivilegeManager.enablePrivilege("UniversalPreferencesWrite"); 

	var str = 'navigator.preference("' + prefKey + '", "' + value + '");'
	eval(str);
}

function SetNetscapePrefBool(prefKey, value)
{
	netscape.security.PrivilegeManager.enablePrivilege("UniversalPreferencesWrite"); 

	var str = 'navigator.preference("' + prefKey + '", ' + value + ');'
	eval(str);
}

function SecureMoveWindow(theWindow, x, y)
{
	netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserWrite"); 

	theWindow.moveTo(x, y);
}

function SecureWindowOpen(theWindow, str1, str2, str3)
{
	netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserWrite"); 

	new_window = theWindow.window.open(str1, str2, str3) ;
	
	return new_window ;
}

function SupressDblClick(e)
{
	return false;
}

function SupressRightMouse(e)
{
	if (e.which > 1)
		return false;

	return routeEvent(e);
}

function SupressDrag(e)
{
	if (e.type = "dragdrop")
		return false;
}

function SupressError(errMsg) 
{
	if (typeof(errMsg) != "string") {
	    java.lang.System.out.println("JS Error: Error loading image");
	    return false;
	}

	if (errMsg.indexOf('netscape/security/ForbiddenTargetException') != -1) {
		alert(getLocalString("Netcaster requires certain privileges in order to run. ") +
			  getLocalString("In order to use Netscape Netcaster, you must grant privileges for netcasting programs. ") +
			  getLocalString("To grant privileges and avoid this message in the future, check the \"Remember this decision\" ") +
			  getLocalString("box before clicking Grant."));
		components["netcaster"].forceCloseNetcaster();
		return true;
	}


	java.lang.System.out.println("JS Error: " + errMsg);

	return true; 
}

function setDebugBool() 
{
	debug = false;
}

function setPlatform() 
{
	var plat = navigator.platform;

	if (plat.indexOf("Win") != -1)
	    platform = 1;
	else if(plat.indexOf("Mac") != -1)
	    platform = 2;
	else
	    platform = 3;
}

function isWindows() {
	return (platform==1) ? true : false;
}

function isMac() {
	return (platform==2) ? true : false;
}

function isUnix() {
	return (platform==3) ? true : false;
}

function getLocalString(keyString)
{
	if ((typeof depth == "undefined") || (depth.titlebar.document.demo == null)) {
		return keyString;
	}

	return depth.titlebar.document.demo.getLocalString(keyString);
}


function getDefaultContainer() {
	if (defaultContainer == null) {
		defaultContainer = GetNetscapePref("netcaster.defaultContainer", "channel", false);
	}

	return defaultContainer;
}


setDebugBool();
setPlatform();

void(0);
